﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Preferences used
'StartAtBoot -  runs in StartAtBootCheck service and turns on or off 'DoNotNag' which determines if we are nagging or not
'DoNotNag - see above
'Frequency -  the actual frequency in miliseconds that we will nag default 1 minute
'FrequencySpin - The Spinner control number corresponing to Frequency
'RingTime -  the actual time in miliseconds that we will ring.  default 2 seconds
'RingTimeSpin - The Spinner control number corresponing to RingTime
'NagPhone - Boolean we are nagging phone calls
'NagText - Boolean we are nagging sms text
'NagEmail -  not currently used
'Vibrate - vibrate on nag
'Ring - ring on nag
'UsrIntervened - flag that the user is there
'NagRingtone - number of the ringtone selected using gringtonemanager
'Volume - volume to play ringtone
'LastCallID - ID of the last call recieved before an event creates a new one
'LastCallDate - DATE  "   "
'LastSMSID - SMS ID   "  " 
'LastSMSDate - SMS DATE  "   "
'NumTrys - Used by checkphonelog service to retry looking for new entry in case it wasn't looged yet
'PrevMode - USed by the PhoneState Logic do determine what to do since it is dependant on what we were at previously

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim RunAtBoot As CheckBox
	Dim NagPhone As CheckBox
	Dim NagText As CheckBox
	'Dim NagEmail As CheckBox
	Dim VibrateCB As CheckBox
	Dim RingCB As CheckBox
	Dim Frequency As Spinner
	Dim RingTime As Spinner
	Dim S As String
	'Dim X As Int
	'Dim B As Boolean
	Dim UseDefaultRingCb As CheckBox
	Dim RingToneCb As Button
'	Dim TestBtn As Button
	Dim RTM As RingtoneManager
	Dim SB1 As SeekBar  'Note that this is just a placeholder - a true control just used to place our "Virtual" one
	Dim VolumeBar2 As HSeekbar
	Dim VolumeLbl As Label
	Dim SliderMax As Int
	Dim DidMessage As Int
	Dim MPW As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
'Dim PH As Phone

Try
	'10/19/12
	'Log(Main.WereNotHere)
	If Main.WereNotHere = False Then
		If NagMod.smgr.getboolean("Nagging") = True Then NagMod.KillAll(False)  '10/22/12
		'Log ("KillAll")
	End If
	Activity.LoadLayout("NagSetup") 
	'Frequency.AddAll(Array As String("10 Seconds","1 Minute","2 Minutes","3 Minutes","4 Minutes","5 Minutes","10 Minutes","30 Minutes","60 Minutes"))
	Frequency.AddAll(Array As String("1 Minute","2 Minutes","3 Minutes","4 Minutes","5 Minutes","10 Minutes","30 Minutes","60 Minutes"))
	RingTime.AddAll(Array As String(".5 Seconds","1 Seconds","1.5 Seconds","2 Seconds","3 Seconds","4 Seconds","5 Seconds"))

	RunAtBoot.Checked = NagMod.smgr.Getboolean("StartAtBoot")
	Frequency.SelectedIndex = NagMod.smgr.GetString("FrequencySpin")
	RingTime.SelectedIndex = NagMod.smgr.GetString("RingTimeSpin")

	NagPhone.checked = NagMod.smgr.Getboolean("NagPhone")
	NagText.checked = NagMod.smgr.Getboolean("NagText")
	VibrateCB.checked = NagMod.smgr.Getboolean("Vibrate")
	RingCB.checked = NagMod.smgr.Getboolean("Ring")
	NagMod.smgr.Setboolean("UsrIntervened", False)
	
	'1/30/13 - Kim fix up caretloc if not set
	S=NagMod.smgr.GetString("CaretLoc")
	If S="" Then NagMod.smgr.SetString("CaretLoc",SB1.Width*.75)
	
	SliderMax = SB1.Width    'PH.VOLUME_MUSIC * 100

	'11/27/12 added CaretLoc
	VolumeBar2.Initialize("NagSetup", "VolumeBar", SB1.Width,SB1.Height, SliderMax, NagMod.smgr.GetString("CaretLoc"))  '11/27/12 added CaretLoc
	Activity.AddView(VolumeBar2.AsView, SB1.Left, SB1.top, SB1.width, SB1.Height)
	VolumeLbl.Visible = NagMod.smgr.Getboolean("NagPhone")
	VolumeBar2.setColors(Colors.rgb(67, 110, 238), Colors.rgb(100, 149, 237) ,  Colors.Blue, Colors.rgb(202, 225, 255 ))
	VolumeLbl.Visible = NagMod.smgr.Getboolean("NagPhone")
	VolumeBar2.base.Visible = NagMod.smgr.Getboolean("NagPhone")
	RingToneCb.Enabled = (NagMod.smgr.GetString("NagRingtone") <> "Nag Internal")
	RingToneCb.Visible = RingCB.Checked
	UseDefaultRingCb.Visible = RingCB.Checked
	SB1.Visible = False
Catch
	ToastMessageShow("There was an error starting Nag your settings are being reset to defaults." & CRLF & LastException.Message,True)
	NagMod.FirstTimeinit
End Try
End Sub

Sub Activity_Resume
	
End Sub

Sub RunAtBoot_CheckedChange(Checked As Boolean)
	NagMod.smgr.Setboolean("StartAtBoot", Checked)
End Sub

Sub NagPhone_CheckedChange(Checked As Boolean)
	NagMod.smgr.Setboolean("NagPhone",Checked)
End Sub

Sub NagText_CheckedChange(Checked As Boolean)
	NagMod.smgr.Setboolean("NagText",Checked)
End Sub

Sub UseDefaultRingCb_CheckedChange(Checked As Boolean)
	
	RingToneCb.enabled = Not(Checked)
	If Checked Then
		NagMod.smgr.SetString("NagRingtone","Nag Internal")
		If NagMod.smgr.Getboolean("PhoneSilenced") = False Then 
			PlaySound.PlayOnce = True
			CancelScheduledService("PlaySound")
			StartServiceAt("PlaySound", DateTime.Now + 500, False)
		End If
	End If
	
End Sub

Sub RingCB_CheckedChange(Checked As Boolean)

	NagMod.smgr.Setboolean("Ring", Checked)
	If Not(Checked) Then VibrateCB.Checked = True
	VolumeLbl.Visible = Checked
	VolumeBar2.base.Visible = Checked
	RingToneCb.Visible = Checked
	UseDefaultRingCb.Visible = Checked
	
End Sub

Sub VibrateCB_CheckedChange(Checked As Boolean)
Dim V As PhoneVibrate

	NagMod.smgr.Setboolean("Vibrate",Checked) 
	If Checked Then V.Vibrate(500)
	If Not(Checked) Then RingCB.Checked = True
	VolumeLbl.Visible = RingCB.Checked
	VolumeBar2.base.Visible = RingCB.Checked
	RingToneCb.Visible = RingCB.Checked
	UseDefaultRingCb.Visible = RingCB.Checked
	
End Sub

Sub Frequency_ItemClick (Position As Int, Value As Object)

Select Case Position
	Case 6: S = 600000
	Case 7: S = 1800000
	Case 8: S = 3600000
	'Case 0: S = 10000
	Case Else: S = (Position + 1) * 60000
End Select
'ToastMessageShow(Position & CRLF & S,True)
'Log  (S & "  " & Value)
NagMod.smgr.SetString("Frequency", S)
NagMod.smgr.SetString("FrequencySpin", Position)

End Sub

Sub RingTime_ItemClick (Position As Int, Value As Object)

Select Case Position
	Case 0:S="500"
	Case 1:S="1000"
	Case 2:S="1500"
	Case 3:S="2000"
	Case 4:S="3000"
	Case 5:S="4000"
	Case 6:S="5000"
End Select
'Log  (S & "  " & Value)
NagMod.smgr.SetString("RingTime",S)
NagMod.smgr.SetString("RingTimeSpin",Position)

End Sub

Sub  RingToneCb_Click
RTM.ShowRingtonePicker("RTM" , RTM.TYPE_RINGTONE, False, NagMod.smgr.GetString("NagRingtone"))
End Sub

Sub RTM_PickerResult (Success As Boolean, Uri As String)
'Log("URI = " & Uri)

If Success Then
	If Uri = "content://settings/system/ringtone" Then    'They have picked default so use ours
		NagMod.smgr.SetString("NagRingtone","Nag Internal")
		UseDefaultRingCb.Checked = True
		RingToneCb.Enabled = False
	Else
		NagMod.smgr.SetString("NagRingtone",Uri)
	End If
End If

End Sub 

Sub VolumeBar_ValueChanged(Value As Int, UserChanged As Boolean)
Dim Ph As Phone, TenPct As Double, MaxVol As Long, NinetyPct As Double
MaxVol = Ph.GetMaxVolume(Ph.VOLUME_MUSIC)
TenPct = MaxVol / 20
NinetyPct = MaxVol - TenPct
If UserChanged Then 
	CancelScheduledService("PlaySound")
	If DidMessage < 2 Then
		ToastMessageShow("Volume setting here is RELATIVE to MEDIA VOLUME in Settings>Sound>Volume", False)
		DidMessage = DidMessage + 1
	End If
	NagMod.smgr.SetString("CaretLoc", Value)
	Select  Case True
		Case( Value = 0)
			NagMod.smgr.SetString("Volume", 0)
		Case  (Value = SliderMax)
			NagMod.smgr.SetString("Volume", MaxVol)
		Case (Value < (SliderMax / 2))
			NagMod.smgr.SetString("Volume",  (TenPct * Value) / (SliderMax / 2))
		Case Else
			NagMod.smgr.SetString("Volume", TenPct + (NinetyPct * ((Value - (SliderMax / 2)) / (SliderMax / 2))))
	End Select
	If NagMod.smgr.Getboolean("PhoneSilenced") = False Then 
		PlaySound.PlayOnce = True
		StartServiceAt("PlaySound", DateTime.Now + 1000, False)
	End If
End If	
'ToastMessageShow(NagMod.smgr.getString("CaretLoc") & "   Vol: " & NagMod.smgr.getString("Volume"),True)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

Main.WereNotHere = Not(UserClosed)

End Sub

Sub LetsTryAndKill

If NagMod.smgr.getboolean("Nagging") = True Then NagMod.KillAll(False)  '10/22/12
'Log ("KillAll")

End Sub

'Sub TestBtn_Click
'Dim MyList As List, CallLog As CallLog, C As CallItem, callType
'Dim MP As MediaPlayer
'Dim Ph As Phone
'
'MP.Initialize
'MP.load(File.DirAssets,  "clong.ogg")
'MP.SetVolume(NagMod.smgr.GetString("Volume"), NagMod.smgr.GetString("Volume"))
''MP.Looping=True
'MP.Play
'
''Msgbox(File.DirRootExternal,"")
''Msgbox(File.Combine(File.DirRootExternal,"Ringtones") & CRLF & File.DirRootExternal & "/Ringtones","")
''
''File.Copy(File.DirAssets, "clong.mp3", File.Combine(File.DirRootExternal,"media/ringtones"), "clong.mp3")
''Return
''Msgbox(File.Combine(File.DirRootExternal,"zzxxq"),"")
'''[File.Copy(File.DirAssets, "clong.mp3", File.Combine(File.DirRootExternal,"ringtone"), "clong.mp3")
'
''Try
''	Msgbox( File.DirAssets,"")
''	Msgbox( RTM.GetContentDir,"")
''	Dim Li As List, zzx As Int
''Li.Initialize
''Li=File.Exists(File.DirAssets)
'	'Log ("File clong.ogg in dir " & File.DirAssets & " = " &  File.Exists(File.DirAssets, "clong.ogg"))
''	If Li.Size > 0 Then
''		For  zzx=0 To Li.Size - 1
''			Msgbox(Li.Get(zzx),"")
''		Next
''	End If
''	File.Copy(File.DirAssets, "clong.ogg", File.DirRootExternal & "/media/xxx", "clong.ogg")
'	'RTM.AddToMediaStore(RTM.GetContentDir, "clong.ogg", "Nag", True, True, True, False)
''Catch
'	'ToastMessageShow(LastException.Message,True)
''	Log(LastException.Message)
''End Try
'
'Log ("Stop_Click")
'Log ("Logged Last Cal ID: " & NagMod.smgr.Getstring("LastCallID") & "  Date: " & NagMod.smgr.Getstring("LastCallDate"))
'MyList = CallLog.GetAll(10)
'For X = 0 To MyList.Size - 1
'	C = MyList.Get(X)
'   Select C.callType
'	    Case C.TYPE_INCOMING
'	        callType="Incoming"
'	    Case C.TYPE_MISSED
'	        callType = "Missed"
'	    Case C.TYPE_OUTGOING
'	        callType = "Outgoing"
'	End Select
'	' name = "" Then name = "N/A"
'	Log("X= " & X & " ID= " & C.Id & "          Number=" & C.Number & ",           Name="& ", Type=" & callType & ", Date=" & DateTime.Date(C.Date) & " : " & DateTime.time(C.Date))
'	Log(C)
'Next
'
'Log("SMS: ")
'Log ("Logged Last SMS ID: " & NagMod.smgr.Getstring("LastSMSID") & "  Date: " & NagMod.smgr.Getstring("LastSMSDate"))
'Dim SmsMessages1 As SmsMessages
'Dim List1 As List
'List1 = SmsMessages1.GetAllSince(DateTime.Add(DateTime.Now, 0, 0, -1))
'For i = 0 To List1.Size - 1
'    Dim Sms As Sms
'    Sms = List1.Get(i)
'    'If Sms.Read=False Then Log(Sms)
'    Log(Sms)
'Next 
'
'End Sub

'went another way. Instead of trying to install my ringtone and setting it as the defaults and adding it to RTM
'just added a use default ringtone CB

'Try
'	'create a directory and install our sound
'	'Msgbox ("Ext Dir " & File.DirRootExternal,"")
'	If File.Exists(File.DirRootExternal, "Nag") = False Then File.MakeDir(File.DirRootExternal, "Nag")
'	If File.Exists(File.DirRootExternal & "/Nag", "ringtones") = False Then File.MakeDir(File.DirRootExternal & "/Nag", "Ringtones")
'	B = False
'	If File.Exists(File.DirRootExternal & "/Nag/Ringtones", "clong.ogg") = False Then 
'		File.Copy(File.DirAssets, "clong.ogg", File.DirRootExternal & "/Nag/Ringtones", "clong.ogg")
'	End If
'	If (File.Exists(File.DirRootExternal & "/Nag/Ringtones", "clong.ogg")) AND (B = True)  Then
'		S =  RTM.AddToMediaStore(File.DirRootExternal & "/Nag/Ringtones", "clong.ogg", "Nag", True, True, True, False)
'		NagMod.smgr.SetString("NagRingtone", S)
'	Else
'		'NagMod.smgr.SetString("NagRingtone", RTM.GetDefault(RTM.TYPE_NOTIFICATION))
'		NagMod.smgr.SetString("NagRingtone","Nag Internal")
'	End If
'Catch
'	NagMod.smgr.SetString("NagRingtone","Nag Internal")
'End Try
'Home Home Button
'F2 Left Softkey / Menu / Settings Button (OR page up)
'Shift+f2 Right Softkey / Star Button (OR page down)
'Esc Back Button
'F3 Call/ dial Button
'F4 Hang up / End call Button
'F5 Search Button
'Ctrl+F5 Volume up (OR + on numeric keyboard with Num Lock off)
'Ctrl+F6 Volume down (OR + on numeric keyboard with Num Lock off)
'f7 Power Button
'Ctrl+F3 Camera Button
'Ctrl+F11 Switch layout orientation portrait/landscape backwards
'Ctrl+F12 Switch layout orientation portrait/landscape forwards
'F8 Toggle cell network
'F9 Toggle code profiling
'Alt+Enter Toggle fullscreen mode
'F6 Toggle trackball mode
 

'DoEvents
'Log("ShutdownClick")
'		MyList = CallLog.GetAll(10)
'		For X = 0 To MyList.Size - 1
'			c = MyList.Get(X)
'		    Select c.callType
'	        Case c.TYPE_INCOMING
'	            callType="Incoming"
'	        Case c.TYPE_MISSED
'	            callType = "Missed"
'	        Case c.TYPE_OUTGOING
'	            callType = "Outgoing"
'	    End Select
'	    ' name = "" Then name = "N/A"
'	    Log("ID= " & c.Id & "          Number=" & c.Number & ",           Name="& ", Type=" & callType & ", Date=" & DateTime.Date(c.Date) & " : " & DateTime.time(c.Date))
'
'		Next
'Log("ShutdownClick - get call by id")
'c = MyList.Get(1)
'Log("ShutdownClick - id to get = " & c.Id)
'
'c = CallLog.GetById(373)
'Log("ShutdownClick - GOT call by id  Date=" & DateTime.Date(c.Date) & " : " & DateTime.time(c.Date))


Sub MPW_EnterPressed
	MPW.Visible=False
	If MPW.Text = "frequency" Then
		NagMod.smgr.SetString("Frequency", 10000)
		ToastMessageShow ("Frequency set to 10 seconds for testing", False)
	End If
	MPW.Text = ""
End Sub

Sub Label2_LongClick
	MPW.PasswordMode = True
	MPW.Visible=True
'	    Dim Id As InputDialog   
'		Id.Hint = Hint
'		Id.Input = Default
'		ret = Id.Show(Prompt, Title, "OK", "","Abbrechen", Null)
'		If ret = -1 Then Return Id.Input Else Return ""

End Sub