﻿Type=Service
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim TMR As Timer, MP As MediaPlayer
	'Dim ttt As SoundPool
	Dim  PlayOnce As Boolean
End Sub
Sub Service_Create

MP.Initialize '10/30 - Moved here to avoid a fatal error in destroy 

End Sub

Sub Service_Start (StartingIntent As Intent)
Dim S As String, RTM As RingtoneManager, Vib As PhoneVibrate
Dim RT As Int, S As String
Dim SmsMessages1 As SmsMessages, Sms As Sms
'Trial
If SetNag.SetTimeStart <> 0 Then  'Trial expired
	Return
End If
'End Trial
If Main.Nag_Changes <> "SuperCaliFragilisticExpialidocious" Then
	'ToastMessageShow("Not Licensed" & CRLF & CRLF & "Nag_Changes: " & Main.Nag_Changes, False)
	S = NagMod.smgr.GetString("NagFailure")
	If S = "" Then  'Wer'e good
	Else If S = "Disa" Then
	'12/18/13 - "NAG" & CRLF & 
		ToastMessageShow("NAG" & CRLF & "This software is Not Licensed or we have been unable to contact the Google servers to verify your license for 3 days or you are not logged in to the account this software was purchased under." & CRLF & "If you think you received this message in error try uninstalling and reinstalling Nag.", True)
	Else
	'12/18/13 - "NAG" & CRLF & 
		ToastMessageShow("NAG" & CRLF & "There has been an error contacting the Google servers To verify your software license. Try uninstalling AND reinstalling Nag'" & CRLF & S, True)
	End If
	StopService("PlaySound")
	Return
End If
Try
	'Check if a message has been read but only if we are nagging - not playing once from Main
	If PlayOnce = False Then
		NagMod.MyList.Initialize
		NagMod.MyList = SmsMessages1.GetAllSince(NagMod.smgr.getstring("LastSMSDate") + 1) 'look for anything 1/1000th of a second newer than what we logged
		'Log("ListCount: " & NagMod.MyList.Size & "  " & NagMod.smgr.getstring("LastSMSDate") & "  " & DateTime.Now)
		If NagMod.MyList.Size > 0 Then
			For RT=0 To NagMod.MyList.Size - 1
				Sms = NagMod.MyList.Get(RT)
				If Sms.Read = True Then  'we have a later messsage that has been read so stop Nagging
					DoNotification.nt.Cancel(1)
					NagMod.smgr.Setboolean("UsrIntervened", True)
					NagMod.smgr.Setboolean("Nagging", False)
					Exit
				End If
			Next
		End If
	End If
'	ToastMessageShow("TESTING MODE Play Sound 1", False)  '1/2 minute - for testing
	If Not(NagMod.smgr.Getboolean("UsrIntervened")) Then
		If NagMod.smgr.Getboolean("PhoneSilenced") Then
			If NagMod.smgr.Getboolean("VibrateWhenSilenced") Then  Vib.Vibrate (RT)
		Else  '12/16/12 Moved this whole If ("Ring") here so ring won't happen if silenced
'	ToastMessageShow("TESTING MODE Play Sound 2", False)  '1/2 minute - for testing
			If NagMod.smgr.GetBoolean("Ring") = True Then
'	ToastMessageShow("TESTING MODE Play Sound 3", False)  '1/2 minute - for testing
				RT = NagMod.smgr.GetString("RingTime")
				S=NagMod.smgr.GetString("NagRingtone")
				If S = "Nag Internal" Then MP.load(File.DirAssets, "clong.ogg") Else MP.load(RTM.GetContentDir,S)
				MP.SetVolume(NagMod.smgr.GetString("Volume"), NagMod.smgr.GetString("Volume"))
				'ToastMessageShow(NagMod.smgr.GetString("Volume"),False)
				MP.Looping=True
				MP.Play
				TMR.Enabled = False
				TMR.Initialize("StopMPPlay", RT)
				TMR.Enabled = True
			End If
			If NagMod.smgr.GetBoolean("Vibrate") = True Then Vib.Vibrate (RT)
		End If
	End If
Catch
	ToastMessageShow("PlaySound Service_Start Error" & CRLF & LastException.Message, True)
	'Log("Playsound service_start" & CRLF & LastException.Message)
End Try
 
End Sub


Sub Service_Destroy
Try
	TMR.Enabled = False
	If MP.IsPlaying Then
		MP.Pause
		MP.Stop
		MP.Release
	End If
	If PlayOnce Then
		PlayOnce = False
		CancelScheduledService("PlaySound")
	Else
		If Not(NagMod.smgr.Getboolean("UsrIntervened")) Then
			StartServiceAt("PlaySound", DateTime.Now + NagMod.smgr.GetString("Frequency"), True)
		End If
	End If
Catch
	ToastMessageShow("PlaySound Service_Destroy Error" & CRLF & LastException.Message, True)
	'Log("Playsound Service_Destroy Error" & LastException.Message)
End Try

End Sub

Sub StopMPPlay_Tick
	StopService("PlaySound")
End Sub