﻿Type=Service
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
Dim NT As Notification
'Dim TryCntr As Int  'If checklog has no new entry then use this counter to retry 5 times
'Dim PSL As PhoneStateListener

End Sub
Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
Dim MState As String
	
	'Starts listening
'	PSL.startListeningForEvent(PSL.LISTEN_MESSAGE_WAITING_INDICATOR)
Try
	'Trial
'	If SetNag.SetTimeStart = 0 Then
'	 	NagMod.TestTrialDate   'Trial Version
'	End If
'	If SetNag.SetTimeStart <> 0 Then
'		NagMod.smgr.SetBoolean("DoNotNag", True)  'Trial
'		'ToastMessageShow("Your Nag Trial Has Expired!", True)
'		'If Not(SetNag.NTF.IsInitialized) Then
'			SetNag.NTF.Initialize	
'			SetNag.NTF.Cancel(1)
'			SetNag.NTF.AutoCancel=True
'			SetNag.NTF.Icon="nag36x36"
'			SetNag.NTF.Vibrate= False
'			SetNag.NTF.SetInfo("Nag", "Stop Nagging!", StopNagging2)
'			SetNag.NTF.Sound = False 
'			'NTF.Light=True
'			'Log("Set Notification")
'			SetNag.NTF.Notify(1)
'			NagMod.KillAll(True)
'		'End If
'		Return
'	End If   'Trial Version
	'Log("DoNoti " & StartingIntent.ExtrasToString)
	If NagMod.smgr.GetBoolean("DoNotNag") Then
		StopService("")
	Else
		NagMod.smgr.setboolean("UsrIntervened", False)
		If StartingIntent.HasExtra("state") Then
			MState=StartingIntent.GetExtra("state")
		Else  'Don't know how we got here
			StopService("DoNotification")
		End If
		If NagMod.smgr.Getboolean("NagPhone") = True Then 
			NagMod.MyList.Initialize
			If MState="RINGING" Then
			Try
				StopService("Playsound")
			Catch
				'Log(LastException.Message)
				ToastMessageShow("DoNotification Service_Start" & CRLF & LastException.Message,True)
			End Try
				'save the last call so we know if we got a new one
				NagMod.GetLastCall
				If NagMod.smgr.Getboolean("Nagging") = False Then NagMod.GetLastSMS
				NagMod.smgr.setboolean("UsrIntervened",False)
			Else If MState="IDLE" Then
				If Not(NagMod.smgr.getboolean("UsrIntervened")) Then
					NagMod.MyList = NagMod.CallLog.GetAll(10)  'Hopefully this forces a flush
					NagMod.smgr.SetString("NumTrys","0")
					'Log("From DoNotif " & DateTime.Now)
					StartServiceAt("CheckPhoneLog",DateTime.Now + 1000,True)
				Else
					NT.Initialize
					NT.Cancel(1)
					NagMod.smgr.Setboolean("Nagging", False)
				End If
			Else If MState = "OFFHOOK" Then
				NagMod.smgr.setboolean("UsrIntervened",True)
				StopService("SetNag")
				NT.Initialize
				NT.Cancel(1)
				NagMod.smgr.Setboolean("Nagging", False)
			End If
		Else
			StopService("DoNotification")
		End If
		'Network state starts here
		'0 = Online
		'1 = Offline
		'3 = Airplane Mode
		If MState = "1" Then  'offline
			'We are going offline but we are not coming out of Airplane mode so get the last call to check for later
			If NagMod.smgr.GetString("PrevMode") = "0" Then
				NagMod.GetLastCall
				If NagMod.smgr.Getboolean("Nagging") = False Then NagMod.GetLastSMS
			Else If NagMod.smgr.GetString("PrevMode") = "3" Then
				StartServiceAt("CheckPhoneLog",DateTime.Now + 1000,True)
			End If
			NagMod.smgr.SetString("PrevMode", MState)
		Else If MState = "0" Then  'online
			If NagMod.smgr.GetString("PrevMode") = "1" Then
				StartServiceAt("CheckPhoneLog",DateTime.Now + 10000,True)  'Give it Time time to get missed calls
			End If
			NagMod.smgr.SetString("PrevMode", MState)
		Else If MState = "3" Then  'Airplane Mode
			NagMod.GetLastCall
			If NagMod.smgr.Getboolean("Nagging") = False Then NagMod.GetLastSMS
			NagMod.smgr.SetString("PrevMode", MState)
		End If
	End If
Catch
	'Log("DoNotification Service_Start" & CRLF & LastException.Message)
	ToastMessageShow("DoNotification Service_Start" & CRLF & LastException.Message,True)
End Try

End Sub

Sub Service_Destroy
'Restart our service if we are, in fact trying to find out if we NEED to set a nag
Try
	If Not(NagMod.smgr.GetBoolean("DoNotNag"))  Then 
		If (NagMod.GetCallState = NagMod.OFFHOOK) Then
			If Not(NagMod.smgr.Getboolean("UsrIntervened")) Then
				StartServiceAt("DoNotification", DateTime.Now + 10000, False)
			End If
		End If
	End If
Catch
	'Log("DoNotification Service_Destroy" & CRLF & LastException.Message)
	ToastMessageShow("DoNotification Service_Destroy" & CRLF & LastException.Message,True)
End Try

End Sub

''Callback invoked when the message-waiting indicator changes.
'Sub PSL_onMessageWaitingIndicatorChanged(mwi As Boolean)
''Log (" Call Waiting " & mwi)
'End Sub

