﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
 	Dim BuyBtn As Button
	Dim UninstallBtn As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	Activity.LoadLayout("TrialExp")
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub DoNothing

End Sub

Sub BuyBtn_Click
Dim i As Intent, Resp As Int, MP As Map
Dim MyFile As PublicFile
Try
	Resp = Msgbox2("Do you want to save your settings to be used by the paid version?", "Save Settings", "Yes", "Cancel", "No", Null) 
	If Resp = DialogResponse.CANCEL Then Return
	If Resp = DialogResponse.POSITIVE Then
		MP.Initialize
		MP.Put("VibrateWhenSilenced", NagMod.smgr.Getboolean("VibrateWhenSilenced"))
		MP.Put("StartAtBoot", NagMod.smgr.Getboolean("StartAtBoot"))
		MP.Put("DoNotNag", NagMod.smgr.Getboolean("DoNotNag"))
		MP.Put("Frequency", NagMod.smgr.GetString("Frequency"))
		MP.Put("FrequencySpin", NagMod.smgr.GetString("FrequencySpin"))
		MP.Put("RingTimeSpin", NagMod.smgr.GetString("RingTimeSpin"))
		MP.Put("RingTime", NagMod.smgr.GetString("RingTime"))
		MP.Put("NagPhone", NagMod.smgr.Getboolean("NagPhone"))
		MP.Put("NagText", NagMod.smgr.Getboolean("NagText"))
		MP.Put("Vibrate", NagMod.smgr.Getboolean("Vibrate"))
		MP.Put("Ring", NagMod.smgr.Getboolean("Ring"))
		MP.Put("Volume", NagMod.smgr.GetString("Volume"))
		MP.Put("NagRingtone", NagMod.smgr.GetString("NagRingtone"))
		MP.Put("PhoneSilenced", NagMod.smgr.Getboolean("PhoneSilenced"))
		MP.Put("LastSilencedPos", NagMod.smgr.GetString("LastSilencedPos"))
		MP.Put("VibrateWhenSilenced", NagMod.smgr.Getboolean("VibrateWhenSilenced"))
		If NagMod.WriteMapToFile(File.DirRootExternal, MyFile.DirDocuments, "NagSettings.sav", MP) Then
		Else If NagMod.WriteMapToFile(File.DirRootExternal, MyFile.DirDownloads, "NagSettings.sav", MP) Then
		Else If NagMod.WriteMapToFile(File.DirRootExternal, MyFile.DirDCIM, "NagSettings.sav", MP) Then
		Else
			Msgbox("Unable to write to external storage. Cannot save your Nag settings!", "Can't Save Settings")
		End If
	End If
	  i.Initialize(i.ACTION_VIEW, "https://play.google.com/store/apps/details?id=com.superlativesoftware.nag&hl=en")
	  StartActivity(i)
Catch
	'Log(LastException.Message)
	ToastMessageShow("T" & CRLF & LastException.Message,True)
End Try
End Sub

Sub UninstallBtn_Click
Dim i As Intent
Try
	If Msgbox2("Are you sure you want to uninstall Nag - Trial?" & "If you do you will lose your settings if you later buy the full version.!", "Uninsall Nag", "Yes", "Cancel", "", Null) = DialogResponse.CANCEL Then Return
	i.Initialize("android.intent.action.DELETE", "package:" & "com.superlativesoftware.nagtrial")
	  StartActivity(i)
Catch
	'Log(LastException.Message)
	ToastMessageShow("T2" & CRLF & LastException.Message,True)
End Try
End Sub

